
//--------------------------------------------------------------------
//     此代码由T4模板自动生成  byzhouhang 20210918
//	   生成时间 2022-06-07 14:09:29 
//     对此文件的更改可能会导致不正确的行为，并且如果重新生成代码，这些更改将会丢失。
using System;
using IRaCIS.Core.Domain.Share;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
using System.Collections.Generic;

namespace IRaCIS.Core.Domain.Models
{
    ///<summary>
    ///VisitTask
    ///</summary>
    [Table("VisitTask")]
    public class VisitTask : Entity, IAuditUpdate, IAuditAdd
    {

        public Guid TrialId { get; set; }

        /// <summary>
        /// CreateUserId
        /// </summary>
        [Required]
        public Guid CreateUserId { get; set; }

        /// <summary>
        /// CreateTime
        /// </summary>
        [Required]
        public DateTime CreateTime { get; set; }

        /// <summary>
        /// UpdateTime
        /// </summary>
        [Required]
        public DateTime UpdateTime { get; set; }

        /// <summary>
        /// UpdateUserId
        /// </summary>
        [Required]
        public Guid UpdateUserId { get; set; }

        /// <summary>
        /// TaskName
        /// </summary>
        [Required]
        public string TaskName { get; set; } = string.Empty;

        /// <summary>
        /// TaskBlindName
        /// </summary>
        [Required]
        public string TaskBlindName { get; set; } = string.Empty;



        /// <summary>
        /// ReadingCategory
        /// </summary>
        [Required]
        public ReadingCategory ReadingCategory { get; set; }

        /// <summary>
        /// CheckPassedTime
        /// </summary>
        public DateTime? CheckPassedTime { get; set; }

        /// <summary>
        /// AllocateTime
        /// </summary>
        public DateTime? AllocateTime { get; set; }

        /// <summary>
        /// SubjectId
        /// </summary>
        [Required]
        public Guid SubjectId { get; set; }

        public Subject Subject { get; set; }

        /// <summary>
        /// Code
        /// </summary>
        [Required]
        public int Code { get; set; }

        /// <summary>
        /// TaskCode
        /// </summary>
        [Required]
        public string TaskCode { get; set; } = string.Empty;

        /// <summary>
        /// IsUrgent
        /// </summary>
        [Required]
        public bool IsUrgent { get; set; }

        /// <summary>
        /// ArmEnum
        /// </summary>
        [Required]
        public int ArmEnum { get; set; }

        public TaskState TaskState { get; set; }


        /// <summary>
        /// DoctorUserId
        /// </summary>
        public Guid? DoctorUserId { get; set; }
        [ForeignKey("DoctorUserId")]

        public User DoctorUser { get; set; }

        public TaskAllocationRule DoctorTaskAllocationRule { get; set; }

        //裁判任务的Id
        public Guid? JudgeVisitTaskId { get; set; }

        public VisitTask JudgeVisitTask { get; set; }

        //对于裁判项而言，触发裁判的列表
        public List<VisitTask> JudgeVisitList { get; set; }



        //建议完成时间
        public int SuggesteDays { get; set; }

        public ReadingTaskState ReadingTaskState { get; set; }

        public DateTime? SignTime { get; set; }

        //是否回退过
        public bool IsReturned { get; set; }

        //是否 重阅
        public bool IsReReading { get; set; }

        //重阅原始任务Id
        public Guid? OriginalReReadingId { get; set; }

        public VisitTask OriginalReReadingTask { get; set; }

        public RequestReturnType RequestReturnType { get; set; } 
        public DateTime? RequestReturnTime { get; set; }
        public string RequestReturnReason { get; set; } = string.Empty;
    }

}
